본문 바로가기
LeetCode/2020 LeetCoding Challenge

LeetCode.H-Index II

by 벤진[Benzene] 2020. 6. 19.

Problem:

Given an array of citations sorted in ascending order (each citation is a non-negative integer) of a researcher, write a function to compute the researcher's h-index.

According to the definition of h-index on Wikipedia: "A scientist has index h if h of his/her N papers have at least h citations each, and the other N − h papers have no more than citations each."

 

Example:

Input: citations = [0,1,3,5,6]

Output: 3

Explanation: [0,1,3,5,6] means the researcher has 5 papers in total and each of them had received 0, 1, 3, 5, 6 citations respectively.   Since the researcher has 3 papers with at least 3 citations each and the remaining   two with no more than 3 citations each, her h-index is 3.

 

Note:

If there are several possible values for h, the maximum one is taken as the h-index.

 

Follow up:

  • This is a follow up problem to H-Index, where citations is now guaranteed to be sorted in ascending order.
  • Could you solve it in logarithmic time complexity?

-Summary-

Solved by binary search

Objective: Find the maximum value of n, such that you have at least n number >= n 

              and the (length of citations list - n) is <= n.

 

Ex) [1,8,9,10] 

answer:3 --> since we have 3 numbers have at least 3 citations and only 1 number is less than 3 citations.

 

모든 문제에 대한 저작권은 LeetCode 회사에 있습니다. [Copyright © 2020 LeetCode]

'LeetCode > 2020 LeetCoding Challenge' 카테고리의 다른 글

LeetCode. Count Complete Tree Nodes  (0) 2020.06.24
LeetCode.Single Number II  (0) 2020.06.23
LeetCode.Surrounded Regions  (0) 2020.06.18
LeetCode. Validate IP Address  (0) 2020.06.17
LeetCode. Search in a Binary Search Tree  (0) 2020.06.16

댓글